/*
**  $VER: pictures.e V0.9B
**
**  Picture Object Definitions.
**
**  (C) Copyright 1996-1997 DreamWorld Productions.
**      All Rights Reserved
*/

OPT MODULE
OPT EXPORT
OPT PREPROCESS

MODULE 'dpkernel/dpkernel','system/register',
       'graphics/blitter','files/files'

/****************************************************************************
** The picture structure for loading and depacking of pictures.
*/

CONST PICVERSION   = 1,
      TAGS_PICTURE = $FFFB0000 OR ID_PICTURE

#define PALETTE (Shl(ID_PALETTE,24) OR Shl(01,16))

OBJECT picture
   head[1]    :ARRAY OF head    /* [00] Standard header structure */        
   bitmap     :PTR TO bitmap    /* [12] Bitmap details */
   header     :PTR TO CHAR      /* [16] Information header */
   options    :LONG             /* [20] IMG_VIDEOMEM, IMG_REMAP ... */
   palette    :PTR TO LONG      /* [24] Original palette */
   source     :PTR TO filename  /* [28] Filename for this picture, if any */
   scrmode    :INT              /* [32] Intended screen mode for picture */
   scrheight  :INT              /* [34] Screen height */
   scrwidth   :INT              /* [36] Screen width */
ENDOBJECT

/*** Picture Tags ***/

CONST PCA_Bitmap     = TAPTR OR 12,
      PCA_Header     = TAPTR OR 16,
      PCA_Options    = TLONG OR 20,
      PCA_Palette    = TAPTR OR 24,
      PCA_Source     = TAPTR OR 28,
      PCA_ScrMode    = TWORD OR 32,
      PCA_ScrHeight  = TWORD OR 34,
      PCA_ScrWidth   = TWORD OR 36,
      PCA_BitmapTags = TSTEPIN OR 12

/*** Image Flags ***/

CONST IMG_RESIZEX     = $00000001,   /* Allow resize on X axis */
      IMG_            = $00000002,   /* */
      IMG_REMAP       = $00000004,   /* Allow remapping */
      IMG_RESIZEY     = $00000008,   /* Allow resize on Y axis */
      IMG_INITIALISED = $80000000    /* This structure has been initialised */
CONST IMG_RESIZE      = IMG_RESIZEX OR IMG_RESIZEY

