/*
**  $VER: sprites.e V0.8B
**
**  Sprite Definitions.
**
**  (C) Copyright 1996-1997 DreamWorld Productions.
**      All Rights Reserved
*/

OPT MODULE
OPT EXPORT
OPT PREPROCESS

MODULE 'gms/dpkernel','graphics/blitter','system/register'

/****************************************************************************
** Sprite object.
*/

CONST SPRVERSION  = 1,
      TAGS_SPRITE = $FFFB0000 OR ID_SPRITE

OBJECT sprite
   head[1]    :ARRAY OF head
   number     :INT   -> Bank number to access 
   data       :LONG  -> Pointer to Sprite graphic 
   xpos       :INT   -> X position 
   ypos       :INT   -> Y position 
   frame      :INT   -> Frame number 
   width      :INT   -> Width in pixels 
   height     :INT   -> Height in pixels 
   amtcolours :INT   -> 4 or 16 
   colstart   :INT   -> Colour bank to access, increments of 16 
   planes     :INT   -> Amount of planes per bank 
   scrmode    :INT   -> HiRes/LoRes/SHiRes 
   fieldpos   :INT   -> Field position in relation to playfields 
   attrib     :INT   -> Attributes (XLONG)
ENDOBJECT

CONST XLONG = $0001

CONST SPA_DATA       = 12 OR TAPTR,
      SPA_NUMBER     = 16 OR TWORD,
      SPA_XCOORD     = 18 OR TWORD,
      SPA_YCOORD     = 20 OR TWORD,
      SPA_FRAME      = 22 OR TWORD,
      SPA_WIDTH      = 24 OR TWORD,
      SPA_HEIGHT     = 26 OR TWORD,
      SPA_AMTCOLOURS = 28 OR TWORD,
      SPA_COLSTART   = 30 OR TWORD,
      SPA_PLANES     = 32 OR TWORD,
      SPA_SCRMODE    = 34 OR TWORD,
      SPA_FIELDPRI   = 36 OR TWORD,
      SPA_ATTRIB     = 38 OR TWORD,
      SPA_OWNER      = 40 OR TAPTR

