/*
**  $VER: dpkbase.e V0.8B
**
**  Definition of the dpkernel base structure.
**
**  (C) Copyright 1996-1997 DreamWorld Productions.
**      All Rights Reserved
*/

OPT MODULE
OPT EXPORT
OPT PREPROCESS

MODULE 'gms/dpkernel','system/register','graphics/screens','exec/libraries'
MODULE 'system/misc','files/files','system/modules'

/*****************************************************************************
** All DPKBase fields are private.  This file is included in the developers
** archive for module writers and debugging purposes only.
*/

OBJECT sscreen
  next    :PTR TO sscreen
  screen  :PTR TO screen
ENDOBJECT

OBJECT dpkbase
  libnode[1]      :ARRAY OF lib
  gemp            :INT              /* Private */
  segList         :LONG             /* Private */
  oldMouseX1      :INT              /* Private */
  oldMouseY1      :INT              /* Private */
  oldMouseX2      :INT              /* Private */
  oldMouseY2      :INT              /* Private */
  vBLPosition     :INT              /* Private */
  scrSwitch       :CHAR             /* Private */
  destruct        :CHAR             /* Private */
  randomSeed      :LONG             /* Random seed */
  blitterUsed     :INT              /* 0 = Free, 1 = Grabbed */
  blitterPriority :INT              /* 0 = NoPriority, 1 = Priority */
  currentScreen   :PTR TO screen    /* Currently displayed screen */
  taskList        :LONG             /* Pointer to list of all current tasks */
  hSync           :INT              /* Private */
  sysObjects      :PTR TO sysobject /* System object list (master) */
  debugActive     :CHAR             /* Set if debugger is currently active */
  scrBlanked      :CHAR             /* Set if screen is currently blanked */
  version         :INT              /* The version of this kernel */
  revision        :INT              /* The revision of this kernel */
  screenList      :PTR TO sscreen   /* List of shown screens, starting from back. */
  childObjects    :PTR TO sysobject /* System object list (hidden & children) */
  referenceDir    :PTR TO directory /* List of references files */
  referenceList   :PTR TO reference /* List of object references */
  screensModule   :PTR TO module    /* Pointer to module */
  blitterModule   :PTR TO module    /* Pointer to module */
  fileModule      :PTR TO module    /* Pointer to module */
  masterModule    :PTR TO module    /* Pointer to module */
  screensBase     :LONG
  blitterBase     :LONG
  fileBase        :LONG
  masterBase      :LONG
  soundModule     :PTR TO module
  soundBase       :LONG
ENDOBJECT

