/*
**  $VER: dpkbase.e V0.9B
**
**  Definition of the dpkernel base structure.
**
**  (C) Copyright 1996-1997 DreamWorld Productions.
**      All Rights Reserved
*/

OPT MODULE
OPT EXPORT
OPT PREPROCESS

MODULE 'dpkernel/dpkernel','system/register','graphics/screens',
       'exec/libraries','system/misc','files/files','system/modules',
       'system/events'

/*****************************************************************************
** All DPKBase fields are private.  This file is included in the developers
** archive for module writers and debugging purposes only.
*/

OBJECT sscreen
  next    :PTR TO sscreen
  screen  :PTR TO screen
ENDOBJECT

OBJECT gvbase
  libnode[1]      :ARRAY OF lib
  screenflip      :INT              /* Private */
  seglist         :LONG             /* Private */
  oldmouseX1      :INT              /* Private */
  oldmouseY1      :INT              /* Private */
  oldmouseX2      :INT              /* Private */
  oldmouseY2      :INT              /* Private */
  vblposition     :INT              /* Private */
  switch          :CHAR             /* Private */
  destruct        :CHAR             /* Private */
  randomseed      :LONG             /* Random seed */
  blitterused     :INT              /* 0 = Free, 1 = Grabbed */
  blitterpriority :INT              /* 0 = NoPriority, 1 = Priority */
  currentScreen   :PTR TO screen    /* Currently displayed screen */
  ticks           :LONG             /* Pointer to list of all current tasks */
  hsync           :INT              /* Private */
  sysobjects      :PTR TO sysobject /* System object list (master) */
  debugactive     :CHAR             /* Set if debugger is currently active */
  scrblanked      :CHAR             /* Set if screen is currently blanked */
  version         :INT              /* The version of this kernel */
  revision        :INT              /* The revision of this kernel */
  screenlist      :PTR TO sscreen   /* List of shown screens, starting from back. */
  childobjects    :PTR TO sysobject /* System object list (hidden & children) */
  referencedir    :PTR TO directory /* List of references files */
  referencelist   :PTR TO reference /* List of object references */
  screensmodule   :PTR TO module    /* Pointer to module */
  blittermodule   :PTR TO module    /* Pointer to module */
  filemodule      :PTR TO module    /* Pointer to module */
  keymodule       :PTR TO module    /* Pointer to module */
  screensbase     :LONG
  blitterbase     :LONG
  filebase        :LONG
  keybase         :LONG
  soundmodule     :PTR TO module
  soundbase       :LONG
  modlist         :PTR TO modentry
  eventarray      :PTR TO evtentry
  flipsignal      :LONG
  fliptask        :LONG
ENDOBJECT

