#ifndef  CLIB_SCREENS_PROTOS_H
#define  CLIB_SCREENS_PROTOS_H

/*
**   $VER: screens_protos.h V0.9B
**
**   C prototypes.
**
**   (C) Copyright 1996-1997 DreamWorld Productions.
**       All Rights Reserved.
*/

#ifndef  SYSTEM_TYPES_H
#include <system/types.h>
#endif

APTR AllocVideoMem(LONG Size, LONG Flags);
void AutoSwitch(void);
void BlankOn(void);
void BlankOff(void);
void FreeVideoMem(APTR MemBlock);
LONG GetScrType(void);
void LockVideo(struct GScreen *);
void MoveBitmap(struct GScreen *);
LONG MoveToFront(struct GScreen *);
LONG MoveToBack(struct GScreen *);
void RefreshScreen(struct GScreen *);
void RemakeScreen(struct GScreen *);
void ResetBitmap(struct GScreen *);
struct GScreen * ReturnDisplay(void);
void SwapBuffers(struct GScreen *);
void Switch(void);
LONG TakeDisplay(struct GScreen *);
void UnlockVideo(struct GScreen *);
void UpdateColour(struct GScreen *, LONG Colour, LONG Value);
void WaitVBL(void);
void WaitAVBL(void);
void WaitRastLine(WORD LinePosition);
void WaitSwitch(struct GScreen *);

/* Palette functions */

void UpdatePalette(struct GScreen *);
WORD ColourMorph(struct GScreen *, WORD FadeState, WORD Speed,
       LONG StartColour, LONG AmtColours, LONG SrcColour, LONG DestColour);
WORD ColourToPalette(struct GScreen *, WORD FadeState, WORD Speed,
       LONG StartColour, LONG AmtColours, APTR Palette, LONG RRGGBB);
void ChangeColours(struct GScreen *, WORD FadeState, APTR Colours,
       WORD StartColour, WORD AmtColours);
WORD PaletteMorph(struct GScreen *, WORD FadeState, WORD Speed,
       LONG StartColour, LONG AmtColours, APTR SrcPalette, APTR DestPalette);
WORD PaletteToColour(struct GScreen *, WORD FadeState, WORD Speed,
       LONG StartColour, LONG AmtColours, APTR Palette, LONG RRGGBB);
void BlankColours(struct GScreen *);

#endif /* CLIB_SCREENS_PROTOS_H */

