#ifndef SYSTEM_DEBUG_H
#define SYSTEM_DEBUG_H 1

/*
**  $VER: debug.h V0.9B
**
**  (C) Copyright 1996-1997 DreamWorld Productions.
**      All Rights Reserved.
*/

#ifndef DPKERNEL_H
#include <dpkernel/dpkernel.h>
#endif

/*****************************************************************************
** This is a list of recognised Debug Messages that can be sent to
** DebugMessage().  Note that these messages will only be seen if you are
** running a GMS debugger such as IceBreaker.  For messages that go to
** ErrCode(), see ERR_* in dpkernel/dpkernel.i.
*/

#define DBG_Error            0   /* Simple error message */
#define DBG_Formatted        1   /* Formatted (printf style) message */
#define DBG_BoldMessage      2   /* Information message */
#define DBG_Message          3
#define DBG_FreeMemBlock     4
#define DBG_Load             5
#define DBG_CopyStructure    6
#define DBG_AddInputHandler  7
#define DBG_RemInputHandler  8
#define DBG_a                9
#define DBG_AllocBlitter     10
#define DBG_FreeBlitter      11
#define DBG_AllocBlitMem     12
#define DBG_AllocVideoMem    13
#define DBG_AllocSoundMem    14
#define DBG_AllocAudio       15
#define DBG_FreeAudio        16
#define DBG_b                17
#define DBG_c                18
#define DBG_FindGMSTask      19
#define DBG_MoveToFront      20
#define DBG_Switch           21
#define DBG_GMSOpened        22
#define DBG_GMSClosed        23
#define DBG_d                24
#define DBG_Get              25
#define DBG_SelfDestruct     26
#define DBG_Armageddon       27
#define DBG_FingerOfDeath    28
#define DBG_InitDestruct     29
#define DBG_BlankOn          30
#define DBG_BlankOff         31
#define DBG_GetObjectList    32
#define DBG_GetObject        33
#define DBG_OpenFile         34
#define DBG_Free             35
#define DBG_MoveToBack       36
#define DBG_TakeDisplay      37
#define DBG_ReturnDisplay    38
#define DBG_Awaken           39
#define DBG_CreateMasks      40
#define DBG_SetBobFrames     41
#define DBG_AllocMemBlock    42
#define DBG_Init             43
#define DBG_Display          44
#define DBG_Hide             45

#define DBG_END              46

#define STEP  (1<<31)
#define DHIGH (1<<30)
#define DMED  (1<<29)
#define DLOW  0         /* Default */

#endif  /* SYSTEM_DEBUG_H */

