	IFND SYSTEM_MISC_I
SYSTEM_MISC_I  SET  1

**
**	$VER: misc.i V0.9B
**
**	(C) Copyright 1996-1997 DreamWorld Productions.
**	    All Rights Reserved
**

	IFND	DPKERNEL_I
	include	'dpkernel/dpkernel.i'
	ENDC

******************************************************************************
* Object Referencing structure.

REFVERSION     = 1
TAGS_REFERENCE = ((ID_SPCTAGS<<16)|ID_REFERENCE)

    STRUCTURE	REF,HEAD_SIZEOF  ;Standard header.
	APTR	REF_Next         ;Next reference.
	APTR	REF_Prev         ;Previous reference.
	WORD	REF_ObjectID     ;ID of the object.
	WORD	REF_Pad          ;Reserved.
	APTR	REF_ObjectName   ;Name of the object.
	APTR	REF_ModName      ;Name of the module containing the object.
	APTR	REF_CheckFile    ;CheckFile code.
	WORD	REF_ModNumber    ;Module ID number.

REFA_ObjectID   = (TWORD|REF_ObjectID)
REFA_ObjectName = (TAPTR|REF_ObjectName)
REFA_ModName    = (TAPTR|REF_ModName)
REFA_CheckFile  = (TAPTR|REF_CheckFile)
REFA_ModNumber  = (TWORD|REF_ModNumber)

******************************************************************************
* Universal Structure.

UNVERSION     = 1
TAGS_UNIVERSE = ((ID_SPCTAGS<<16)|ID_UNIVERSE)

   STRUCTURE	UN,HEAD_SIZEOF
	APTR	UN_Palette
	WORD	UN_Planes
	WORD	UN_ScrWidth
	WORD	UN_ScrHeight
	WORD	UN_Width
	WORD	UN_ByteWidth
	WORD	UN_Height
	APTR	UN_Task
	LONG	UN_Frequency
	LONG	UN_AmtColours
	WORD	UN_ScrMode
	WORD	UN_ScrType
	APTR	UN_Source
	APTR	UN_dedScreenLink
	APTR	UN_Rasterlist
	WORD	UN_ScrXOffset
	WORD	UN_ScrYOffset
	WORD	UN_PicYOffset
	WORD	UN_PicXOffset
	WORD	UN_Channel
	WORD	UN_Priority
	LONG	UN_Length
	WORD	UN_Octave
	WORD	UN_Volume

******************************************************************************
* The SysObject structure.

SOVERSION      = 1
TAGS_SYSOBJECT = ((ID_SPCTAGS<<16)|ID_SYSOBJECT)

   STRUCTURE	SysObject,HEAD_SIZEOF
	APTR	SO_Prev         ;Previous object in the list.
	APTR	SO_Next         ;Next object in the list.
	WORD	SO_ObjectID     ;ID for the object (eg ID_PICTURE, ID_HIDDEN).
	WORD	SO_ClassID      ;ID for the class.
	APTR	SO_Name         ;String pointer to the name of this object.
	APTR	SO_CopyToUnv    ;> Copy to universe.
	APTR	SO_CopyFromUnv  ;> Copy from universe.
	APTR	SO_CheckFile    ;> Check for file recognition.
	APTR	SO_Load         ;> Load a file that belongs to this object.
	APTR	SO_Display      ;> Display the object inside its container.
	APTR	SO_Get          ;> Get object.
	APTR	SO_Free         ;> Free object.
	APTR	SO_Init         ;> Initialise object.
	APTR	SO_Read         ;> Read some data from the object.
	APTR	SO_Write        ;> Write some data to the object.
	APTR	SO_Open         ;> Open this object as a virtual file.
	APTR	SO_Hide         ;> Hide/Remove the object from the display.
	APTR	SO_Close        ;> Close the data filing section of this object.
	APTR	SO_Save         ;> Save this entire object as a file.
	APTR	SO_Query        ;> Query the information held on this object.
	APTR	SO_Activate     ;> Perform the native action for this object.
	APTR	SO_Deactivate   ;> End the native action for this object.
	APTR	SO_Draw         ;> Draw an object inside its container.
	APTR	SO_Clear        ;> Clear an object from its container.
	APTR	SO_Reset        ;> Reset the object.
	APTR	SO_Flush        ;> Flush any buffered data in the object.
	APTR	SO_TagTrigger   ;> Special routine handled by TagInit().
	APTR	SO_Master       ;Reference to master if this is a child.
	APTR	SO_Lock         ;> Lock an objects location and declare ownership.
	APTR	SO_Unlock       ;> Unlock an object.
	APTR	SO_Detach       ;> Detach an object from a parent.

SOA_ClassID     = TAPTR|SO_ClassID
SOA_CopyToUnv   = TAPTR|SO_CopyToUnv
SOA_CopyFromUnv = TAPTR|SO_CopyFromUnv
SOA_CheckFile   = TAPTR|SO_CheckFile
SOA_Load        = TAPTR|SO_Load
SOA_Display     = TAPTR|SO_Display
SOA_Get         = TAPTR|SO_Get
SOA_Free        = TAPTR|SO_Free
SOA_Init        = TAPTR|SO_Init
SOA_Read        = TAPTR|SO_Read
SOA_Write       = TAPTR|SO_Write
SOA_Open        = TAPTR|SO_Open
SOA_Hide        = TAPTR|SO_Hide
SOA_Close       = TAPTR|SO_Close
SOA_Save        = TAPTR|SO_Save
SOA_Query       = TAPTR|SO_Query
SOA_Activate    = TAPTR|SO_Activate
SOA_Deactivate  = TAPTR|SO_Deactivate
SOA_Draw        = TAPTR|SO_Draw
SOA_Clear       = TAPTR|SO_Clear
SOA_Reset       = TAPTR|SO_Reset
SOA_Flush       = TAPTR|SO_Flush
SOA_TagTrigger  = TAPTR|SO_TagTrigger
SOA_Lock	= TAPTR|SO_Lock
SOA_Unlock	= TAPTR|SO_Unlock
SOA_Detach      = TAPTR|SO_Detach

  ENDC	;SYSTEM_MISC_I
